"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = function(target, all) {
    for(var name in all)__defProp(target, name, {
        get: all[name],
        enumerable: true
    });
};
var __copyProps = function(to, from, except, desc) {
    if (from && typeof from === "object" || typeof from === "function") {
        var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
        try {
            var _loop = function() {
                var key = _step.value;
                if (!__hasOwnProp.call(to, key) && key !== except) __defProp(to, key, {
                    get: function() {
                        return from[key];
                    },
                    enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable
                });
            };
            for(var _iterator = __getOwnPropNames(from)[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true)_loop();
        } catch (err) {
            _didIteratorError = true;
            _iteratorError = err;
        } finally{
            try {
                if (!_iteratorNormalCompletion && _iterator.return != null) {
                    _iterator.return();
                }
            } finally{
                if (_didIteratorError) {
                    throw _iteratorError;
                }
            }
        }
    }
    return to;
};
var __toCommonJS = function(mod) {
    return __copyProps(__defProp({}, "__esModule", {
        value: true
    }), mod);
};
// test/e2e/safeTypeNames.ts
var safeTypeNames_exports = {};
__export(safeTypeNames_exports, {
    input: function() {
        return input;
    },
    options: function() {
        return options;
    }
});
module.exports = __toCommonJS(safeTypeNames_exports);
var input = {
    definitions: {
        "stra'nge#name": {
            properties: {
                a: {
                    type: "string"
                },
                b: {
                    type: "integer"
                }
            },
            additionalProperties: false,
            required: [
                "a"
            ]
        },
        keepUPPERCASE: {
            properties: {
                a: {
                    enum: [
                        "a",
                        "b",
                        "c"
                    ]
                }
            }
        },
        snake_case: {
            properties: {
                a: {
                    type: "boolean"
                }
            }
        },
        _startsWithUnderscore: {
            properties: {
                a: {
                    type: "boolean"
                }
            }
        },
        _StartsWithUnderscoreUppercase: {
            properties: {
                a: {
                    type: "boolean"
                }
            }
        },
        EndsWithUnderscore_: {
            properties: {
                a: {
                    type: "boolean"
                }
            }
        },
        UPPER_CASE: {
            properties: {
                a: {
                    type: "boolean"
                }
            }
        },
        ______________: {
            properties: {
                a: {
                    type: "boolean"
                }
            }
        },
        camelCase: {
            properties: {
                a: {
                    type: "float"
                }
            }
        },
        "kebab-case": {
            properties: {
                a: {
                    type: "string"
                }
            }
        },
        " startsWithSpace": {
            properties: {
                a: {
                    type: "string"
                }
            }
        },
        "contains space": {
            properties: {
                a: {
                    type: "string"
                }
            }
        },
        "5tartsWithDigit": {
            properties: {
                a: {
                    type: "string"
                }
            }
        },
        " 5tartsWithBlankAndDigit": {
            properties: {
                a: {
                    type: "string"
                }
            }
        },
        endsWithDigi7: {
            properties: {
                a: {
                    type: "string"
                }
            }
        },
        contains4digit: {
            properties: {
                a: {
                    type: "string"
                }
            }
        },
        ".startsWithPeriod": {
            properties: {
                a: {
                    type: "string"
                }
            }
        },
        "endsWithPeriod.": {
            properties: {
                a: {
                    type: "string"
                }
            }
        },
        "contains...period": {
            properties: {
                a: {
                    type: "string"
                }
            }
        },
        ",startsWithComma": {
            properties: {
                a: {
                    type: "string"
                }
            }
        },
        "endsWithComma,": {
            properties: {
                a: {
                    type: "string"
                }
            }
        },
        "contains,,Comma": {
            properties: {
                a: {
                    type: "string"
                }
            }
        },
        $startsWithDollar: {
            properties: {
                a: {
                    type: "string"
                }
            }
        },
        endsWithDollar$: {
            properties: {
                a: {
                    type: "string"
                }
            }
        },
        contains$Dollar: {
            properties: {
                a: {
                    type: "string"
                }
            }
        },
        $: {
            properties: {
                a: {
                    type: "string"
                }
            }
        },
        UPPERCASE: {
            properties: {
                a: {
                    type: "string"
                }
            }
        },
        Startsuppercase: {
            properties: {
                a: {
                    type: "string"
                }
            }
        }
    }
};
var options = {
    unreachableDefinitions: true
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
    input: input,
    options: options
});
